<?php
//ļͼƬϴ
/*
ʹ÷
function _upload($upload_dir){
	$upload = new UploadFile();
	//ϴļС
	$upload->maxSize=1024*1024*2;//2M
	//ϴļ
	$upload->allowExts  = explode(',','jpg,gif,png,bmp');

	//øϴĿ¼
	$upload->savePath ='../images/'.$upload_dir."/";
	$upload->saveRule = cp_uniqid;

	if(!$upload->upload())
	 {
		//ϴ쳣
		$this->error($upload->getErrorMsg());
	}
	else 
	{
		//ȡóɹϴļϢ
		return $upload->getUploadFileInfo();
	}
}
*/
class UploadFile{

    // ϴļֵ
    public $maxSize = -1;

    // Ƿֶ֧ļϴ
    public $supportMulti = true;

    // ϴļ׺
    //  ղ׺
    public $allowExts = array();

    // ϴļ
    // ղ
    public $allowTypes = array();

    // ʹöϴͼƬͼ
    public $thumb   =  false;
    // ͼ
    public $thumbMaxWidth;
    // ͼ߶
    public $thumbMaxHeight;
    // ͼǰ׺
    public $thumbPrefix   =  'thumb_';
    public $thumbSuffix  =  '';
    // ͼ·
    public $thumbPath = '';
    // ͼļ
    public $thumbFile		=	'';
    // ǷƳԭͼ
    public $thumbRemoveOrigin = false;
    // ѹͼƬļϴ
    public $zipImages = false;
    // Ŀ¼ļ
    public $autoSub   =  false;
    // Ŀ¼ʽ ʹhash date
    public $subType   = 'hash';
    public $dateFormat = 'Ymd';
    public $hashLevel =  1; // hashĿ¼
    // ϴļ·
    public $savePath = '';
    public $autoCheck = true; // ǷԶ鸽
    // ͬǷ񸲸
    public $uploadReplace = false;

    // ϴļ
    //  time uniqid com_create_guid 
    // һκβĺ ʹԶ庯
    public $saveRule = '';

    // ϴļHash
    //  md5_file sha1_file 
    public $hashType = 'md5_file';

    // Ϣ
    private $error = '';

    // ϴɹļϢ
    private $uploadFileInfo ;

    /**
     +----------------------------------------------------------
     * ܹ
     +----------------------------------------------------------
     * @access public
     +----------------------------------------------------------
     */
    public function __construct($maxSize='',$allowExts='',$allowTypes='',$savePath='',$saveRule='')
    {
        if(!empty($maxSize) && is_numeric($maxSize)) {
            $this->maxSize = $maxSize;
        }
        if(!empty($allowExts)) {
            if(is_array($allowExts)) {
                $this->allowExts = array_map('strtolower',$allowExts);
            }else {
                $this->allowExts = explode(',',strtolower($allowExts));
            }
        }
        if(!empty($allowTypes)) {
            if(is_array($allowTypes)) {
                $this->allowTypes = array_map('strtolower',$allowTypes);
            }else {
                $this->allowTypes = explode(',',strtolower($allowTypes));
            }
        }
	   if(!empty($savePath)) {
            $this->savePath = $savePath;
        }	
        if(!empty($saveRule)) {
            $this->saveRule = $saveRule;
        }
	
        
    }

    private function save($file)
    {
        $filename = $file['savepath'].$file['savename'];
        if(!$this->uploadReplace && is_file($filename)) {
            // ͬļ
            $this->error	=	'ļѾڣ'.$filename;
            return false;
        }
        // ͼļ ļʽ
        if( in_array(strtolower($file['extension']),array('gif','jpg','jpeg','bmp','png','swf')) && false === getimagesize($file['tmp_name'])) {
            $this->error = 'Ƿͼļ';
            return false;
        }
        if(!move_uploaded_file($file['tmp_name'], iconv('utf-8','gbk',$filename))) {
            $this->error = 'ļϴ';
            return false;
        }
        if($this->thumb && in_array(strtolower($file['extension']),array('gif','jpg','jpeg','bmp','png'))) {
            $image =  getimagesize($filename);
            if(false !== $image) {
                //ͼļͼ
                $thumbWidth		=	explode(',',$this->thumbMaxWidth);
                $thumbHeight		=	explode(',',$this->thumbMaxHeight);
                $thumbPrefix		=	explode(',',$this->thumbPrefix);
                $thumbSuffix = explode(',',$this->thumbSuffix);
                $thumbFile			=	explode(',',$this->thumbFile);
                $thumbPath    =  $this->thumbPath?$this->thumbPath:$file['savepath'];
                // ͼͼ
				if(file_exists(dirname(__FILE__).'/Image.class.php'))
				{
					require_once(dirname(__FILE__).'/Image.class.php');
					$realFilename  =  $this->autoSub?basename($file['savename']):$file['savename'];
					for($i=0,$len=count($thumbWidth); $i<$len; $i++) {
						$thumbname	=	$thumbPath.$thumbPrefix[$i].substr($realFilename,0,strrpos($realFilename, '.')).$thumbSuffix[$i].'.'.$file['extension'];
						Image::thumb($filename,$thumbname,'',$thumbWidth[$i],$thumbHeight[$i],true);
					}
					if($this->thumbRemoveOrigin) {
						// ͼ֮ɾԭͼ
						unlink($filename);
					}
				}
            }
        }
        if($this->zipImags) {
            // TODO ͼƬѹ߽ѹ

        }
        return true;
    }

    /**
     +----------------------------------------------------------
     * ϴļ
     +----------------------------------------------------------
     * @access public
     +----------------------------------------------------------
     * @param string $savePath  ϴļ·
     +----------------------------------------------------------
     * @return string
     +----------------------------------------------------------
     * @throws ThinkExecption
     +----------------------------------------------------------
     */
    public function upload($savePath ='')
    {
        //ָļϵͳĬ
        if(empty($savePath))
            $savePath = $this->savePath;
        // ϴĿ¼
        if(!is_dir($savePath)) {
            // Ŀ¼Ƿ
            if(is_dir(base64_decode($savePath))) {
                $savePath	=	base64_decode($savePath);
            }else{
                // ԴĿ¼
                if(!mkdir($savePath)){
                    $this->error  =  'ϴĿ¼'.$savePath.'';
                    return false;
                }
            }
        }else {
            if(!is_writeable($savePath)) {
                $this->error  =  'ϴĿ¼'.$savePath.'д';
                return false;
            }
        }
        $fileInfo = array();
        $isUpload   = false;

        // ȡϴļϢ
        // $_FILESϢ
        $files	 =	 $this->dealFiles($_FILES);
        foreach($files as $key => $file) {
            //Чϴ
            if(!empty($file['name'])) {
                //ǼϴļչϢ
                $file['key']          =  $key;
                $file['extension']  = $this->getExt($file['name']);
                $file['savepath']   = $savePath;
                $file['savename']   = $this->getSaveName($file);

                // Զ鸽
                if($this->autoCheck) {
                    if(!$this->check($file))
                        return false;
                }

                //ϴļ
                if(!$this->save($file)) return false;
				/*
                if(function_exists($this->hashType)) {
                    $fun =  $this->hashType;
                    $file['hash']   =  $fun(auto_charset($file['savepath'].$file['savename'],'utf-8','gbk'));
                }
				*/
                //ϴɹ󱣴ļϢط
                unset($file['tmp_name'],$file['error']);
                $fileInfo[] = $file;
                $isUpload   = true;
            }
        }
        if($isUpload) {
            $this->uploadFileInfo = $fileInfo;
            return true;
        }else {
            $this->error  =  'ûѡϴļ';
            return false;
        }
    }

    /**
     +----------------------------------------------------------
     * תϴļΪȷķʽ
     +----------------------------------------------------------
     * @access private
     +----------------------------------------------------------
     * @param array $files  ϴļ
     +----------------------------------------------------------
     * @return array
     +----------------------------------------------------------
     */
    private function dealFiles($files) {
       $fileArray = array();
       foreach ($files as $file){
           if(is_array($file['name'])) {
               $keys = array_keys($file);
               $count	 =	 count($file['name']);
               for ($i=0; $i<$count; $i++) {
                   foreach ($keys as $key)
                       $fileArray[$i][$key] = $file[$key][$i];
               }
           }else{
               $fileArray	=	$files;
           }
           break;
       }
       return $fileArray;
    }

    /**
     +----------------------------------------------------------
     * ȡϢ
     +----------------------------------------------------------
     * @access public
     +----------------------------------------------------------
     * @param string $errorNo  
     +----------------------------------------------------------
     * @return void
     +----------------------------------------------------------
     * @throws ThinkExecption
     +----------------------------------------------------------
     */
    protected function error($errorNo)
    {
         switch($errorNo) {
            case 1:
                $this->error = 'ϴļ php.ini  upload_max_filesize ѡƵֵ';
                break;
            case 2:
                $this->error = 'ϴļĴС HTML  MAX_FILE_SIZE ѡֵָ';
                break;
            case 3:
                $this->error = 'ļֻвֱϴ';
                break;
            case 4:
                $this->error = 'ûļϴ';
                break;
            case 6:
                $this->error = 'Ҳʱļ';
                break;
            case 7:
                $this->error = 'ļдʧ';
                break;
            default:
                $this->error = 'δ֪ϴ';
        }
        return ;
    }

    /**
     +----------------------------------------------------------
     * ϴļȡñļ
     +----------------------------------------------------------
     * @access private
     +----------------------------------------------------------
     * @param string $filename 
     +----------------------------------------------------------
     * @return string
     +----------------------------------------------------------
     */
    private function getSaveName($filename)
    {
        $rule = $this->saveRule;
        if(empty($rule)) {//ûж򱣳ļ
            $saveName = $filename['name'];
        }else {
            if(function_exists($rule)) {
                //ʹúһΨһļʶ
                $saveName = $rule().".".$filename['extension'];
            }else {
                //ʹøļΪʶ
                $saveName = $rule.".".$filename['extension'];
            }
        }
        if($this->autoSub) {
            // ʹĿ¼ļ
            $saveName   =  $this->getSubName($filename).'/'.$saveName;
        }
        return $saveName;
    }

    /**
     +----------------------------------------------------------
     * ȡĿ¼
     +----------------------------------------------------------
     * @access private
     +----------------------------------------------------------
     * @param array $file  ϴļϢ
     +----------------------------------------------------------
     * @return string
     +----------------------------------------------------------
     */
    private function getSubName($file)
    {
        switch($this->subType) {
            case 'date':
                $dir   =  date($this->dateFormat,time());
                break;
            case 'hash':
            default:
                $name = md5($file['savename']);
                $dir   =  '';
                for($i=0;$i<$this->hashLevel;$i++) {
                    $dir   .=  $name{0}.'/';
                }
                break;
        }
        if(!is_dir($file['savepath'].$dir)) {
            mkdir($file['savepath'].$dir);
        }
        return $dir;
    }

    /**
     +----------------------------------------------------------
     * ϴļ
     +----------------------------------------------------------
     * @access private
     +----------------------------------------------------------
     * @param array $file ļϢ
     +----------------------------------------------------------
     * @return boolean
     +----------------------------------------------------------
     */
    private function check($file) {
        if($file['error']!== 0) {
            //ļϴʧ
            //
            $this->error($file['error']);
            return false;
        }

        //ļMime
        if(!$this->checkType($file['type'])) {
            $this->error = 'ϴļMIMEͲ';
            return false;
        }
        //ļ
        if(!$this->checkExt($file['extension'])) {
            $this->error ='ϴļͲ';
            return false;
        }
        //ļϴɹԶ
        //ļС
        if(!$this->checkSize($file['size'])) {
            $this->error = 'ϴļСƣ';
            return false;
        }

        //ǷϷϴ
        if(!$this->checkUpload($file['tmp_name'])) {
            $this->error = 'Ƿϴļ';
            return false;
        }
        return true;
    }

    /**
     +----------------------------------------------------------
     * ϴļǷϷ
     +----------------------------------------------------------
     * @access private
     +----------------------------------------------------------
     * @param string $type 
     +----------------------------------------------------------
     * @return boolean
     +----------------------------------------------------------
     */
    private function checkType($type)
    {
        if(!empty($this->allowTypes))
            return in_array(strtolower($type),$this->allowTypes);
        return true;
    }


    /**
     +----------------------------------------------------------
     * ϴļ׺ǷϷ
     +----------------------------------------------------------
     * @access private
     +----------------------------------------------------------
     * @param string $ext ׺
     +----------------------------------------------------------
     * @return boolean
     +----------------------------------------------------------
     */
    private function checkExt($ext)
    {
        if(!empty($this->allowExts))
            return in_array(strtolower($ext),$this->allowExts,true);
        return true;
    }

    /**
     +----------------------------------------------------------
     * ļСǷϷ
     +----------------------------------------------------------
     * @access private
     +----------------------------------------------------------
     * @param integer $size 
     +----------------------------------------------------------
     * @return boolean
     +----------------------------------------------------------
     */
    private function checkSize($size)
    {
        return !($size > $this->maxSize) || (-1 == $this->maxSize);
    }

    /**
     +----------------------------------------------------------
     * ļǷǷύ
     +----------------------------------------------------------
     * @access private
     +----------------------------------------------------------
     * @param string $filename ļ
     +----------------------------------------------------------
     * @return boolean
     +----------------------------------------------------------
     */
    private function checkUpload($filename)
    {
        return is_uploaded_file($filename);
    }

    /**
     +----------------------------------------------------------
     * ȡϴļĺ׺
     +----------------------------------------------------------
     * @access private
     +----------------------------------------------------------
     * @param string $filename ļ
     +----------------------------------------------------------
     * @return boolean
     +----------------------------------------------------------
     */
    private function getExt($filename)
    {
        $pathinfo = pathinfo($filename);
        return $pathinfo['extension'];
    }

    /**
     +----------------------------------------------------------
     * ȡϴļϢ
     +----------------------------------------------------------
     * @access public
     +----------------------------------------------------------
     * @return array
     +----------------------------------------------------------
     */
    public function getUploadFileInfo()
    {
        return $this->uploadFileInfo;
    }

    /**
     +----------------------------------------------------------
     * ȡһδϢ
     +----------------------------------------------------------
     * @access public
     +----------------------------------------------------------
     * @return string
     +----------------------------------------------------------
     */
    public function getErrorMsg()
    {
        return $this->error;
    }

}//ඨ
?>